<template>
  <mt-box padding="0">
    <header class="columns mt-header">
      <h3 class="is-size-6 column"><slot></slot></h3>
      <div class="column is-narrow has-text-grey">
        {{ getFullsize() }}<b-icon icon="account" size="is-small" class="has-text-grey-light" />
      </div>
    </header>
    <mt-filtre-categorie
      :fullsize="getFullsize()"
      :categories="getCorps()"
      theme="onglet"
      label-properties="code"
      @select-all="loadStatus"
      @select-categorie="filtreCategorie"
    ></mt-filtre-categorie>
    <span v-if="autresUnites" class="is-size-7 has-text-weight-semibold mt-unite">{{ activite.organisme.code }}</span>
    <div v-if="autresUnites && etapeStatut.partipantLoaded.filtrer.length === 0" class="mt-grey is-size-7 mt-list">
      Aucun Pax.
    </div>
    <mt-list v-slot="{ item: filtre }" :list="etapeStatut.partipantLoaded.filtrer">
      <mt-list-item
        :class="{ 'mt-list-item-selected': filtre.utilisateur.id === utilisateur.id }"
        @click="ouvreInfoPerso(filtre.utilisateur)"
      >
        <div class="columns is-mobile">
          <div class="column">
            <mt-utilisateur :utilisateur="filtre.utilisateur" />
          </div>
          <div class="column is-narrow">
            <mt-choix-mark :choix="filtre.choix" />
          </div>
        </div>
      </mt-list-item>
    </mt-list>
    <div v-if="autresUnites">
      <div v-for="(etapeEnfant, index1) in etapesEnfants" :key="`etapeEnfant${index1}`">
        <span class="is-size-7 has-text-weight-semibold mt-unite">{{ etapeEnfant.organisme.code }}</span>
        <div
          v-if="
            autresUnites &&
              etapeEnfant.etapes[index.etape].etapesStatuts[index.etapeStatut].partipantLoaded.filtrer.length === 0
          "
          class="mt-grey is-size-7 mt-list"
        >
          Aucun Pax.
        </div>
        <mt-list
          v-slot="{ item: filtre }"
          :list="etapeEnfant.etapes[index.etape].etapesStatuts[index.etapeStatut].partipantLoaded.filtrer"
        >
          <mt-list-item
            :class="{ 'mt-list-item-selected': filtre.utilisateur.id === utilisateur.id }"
            @click="ouvreInfoPerso(filtre.utilisateur)"
          >
            <div class="columns is-mobile">
              <div class="column mt-grey">
                <mt-utilisateur :utilisateur="filtre.utilisateur" />
              </div>
              <div class="column is-narrow">
                <mt-choix-mark :choix="filtre.choix" />
              </div>
            </div>
          </mt-list-item>
        </mt-list>
      </div>
    </div>
    <mt-infos-perso :ouvert.sync="ouvert" :utilisateur="utilisateurSelected" :organismes="organismes"> </mt-infos-perso>
  </mt-box>
</template>

<script>
import MtBox from '~/components/base/box';
import MtFiltreCategorie from '~/components/filtre/filtre-categorie/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import userMixin from '~/components/mixins/userMixin';
import MtInfosPerso from '~/components/pax/mt-infos-perso';
import MtChoixMark from '~/components/activity/partipation/choix-mark';

export default {
  components: {
    MtChoixMark,
    MtInfosPerso,
    MtUtilisateur,
    MtListItem,
    MtList,
    MtFiltreCategorie,
    MtBox,
  },
  mixins: [userMixin],
  props: {
    etapeStatut: {
      type: Object,
      default: () => {},
    },
    etapesEnfants: {
      type: Array,
      default: () => [],
    },
    activite: {
      type: Object,
      default: () => {},
    },
    index: {
      type: Object,
      default: () => {},
    },
    autresUnites: {
      type: Boolean,
      default: () => false,
    },
  },
  data() {
    return {
      ouvert: false,
      utilisateurSelected: {},
      organismes: [],
    };
  },
  methods: {
    async ouvreInfoPerso(utilisateur) {
      this.organismes = await this.$api.utilisateur(utilisateur.id).organismesByEnfantOrderByHierarchie();
      this.ouvert = true;
      this.utilisateurSelected = utilisateur;
    },
    getFullsize() {
      let ret = this.etapeStatut.partipantLoaded.fullsize;
      if (this.autresUnites) {
        for (let l = 0; l < this.etapesEnfants.length; l += 1) {
          ret += this.etapesEnfants[l].etapes[this.index.etape].etapesStatuts[this.index.etapeStatut].partipantLoaded
            .fullsize;
        }
      }
      return ret;
    },
    getCorps() {
      const ret = JSON.parse(JSON.stringify(this.etapeStatut.partipantLoaded.corps));
      if (this.autresUnites) {
        for (let l = 0; l < this.etapesEnfants.length; l += 1) {
          for (let i = 0; i < 3; i += 1) {
            const mEtape = this.etapesEnfants[l].etapes[this.index.etape];
            ret[i].count += mEtape.etapesStatuts[this.index.etapeStatut].partipantLoaded.corps[i].count;
          }
        }
      }
      return ret;
    },
    loadStatus() {
      this.$emit('unfilter-etape', {
        index: this.index,
      });
    },
    filtreCategorie(categorie) {
      this.$emit('filtrer-etape', {
        categorie,
        index: this.index,
      });
    },
    getIdOrganisme({
      affectation: {
        organisme: { id },
      },
    }) {
      return id;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

h3 {
  color: $grey-dark;
  font-weight: bold;
  text-transform: uppercase;
}
.mt-header {
  margin-bottom: 0.5rem;
  padding: 1rem 1.5rem 0;
}
.mt-box {
  min-height: 42vh;
}
/deep/ {
  .mt-list {
    margin: 0.1rem 1.5rem;
  }
  .mt-list li:first-child {
    border-top: 0 none transparent;
  }
  .mt-list .mt-list-item {
    padding: 0.4em 0;
    border-bottom-color: $pale-grey-three;
    cursor: pointer;

    .mt-utilisateur {
      cursor: pointer;
    }
  }
}
.mt-unite {
  color: #666ee8;
  margin: 1rem;
}
</style>
